var	M={}, V={}, C, deviceReady = $.Deferred(),
	appLang="it", localizedStrings={}, reverseLocalized={},
	AVAILABLE_LANGUAGES={en: true, it: true}, DEFAULT_LANGUAGE="it"
; // end of globals

// not really needed since the preset is set in the lang file
$.mobiscroll.setDefaults({
	dateFormat: "dd/mm/yy",
	theme: 'jqm'
});


/******************************************************************************

					MODELS	

******************************************************************************/
/* configurazione */
var CommonModel=Backbone.Model.extend({
	fetchFailureHandler: function(){
		this._fetchFailed=true;
		var _self=this, _originalArguments=arguments;
		V.dialog.confirm(
			C.getLocalizedString("Non riesco ad accedere ad internet oppure si è verificato un errore sul server. Vuoi riprovare? Puoi anche decidere di annullare, tuttavia non potrai visualizzare correttamente questa pagina."),
			function(){
				Backbone.Model.prototype.fetch.apply(_self,_originalArguments);
			},
			function(){
				$.mobile.changePage("#index");
			}
		);
	},

	fetchFailureHandlerNoCancel: function(){
		this._fetchFailed=true;
		var _self=this, _originalArguments=arguments;
		V.dialog.alert(
			C.getLocalizedString("Non riesco ad accedere ad internet oppure si è verificato un errore sul server. Attiva la connessione e premi Ok."),
			function(){
				Backbone.Model.prototype.fetch.apply(_self,_originalArguments);
			}
		);
	},

	fetchSuccessHandler: function(m){
		m._fetchFailed=false;
	}
});

var ConfigModel=Backbone.Model.extend({
	//urlRemote: "/malpensa_shuttle/_ws/config.cfm?psw=mxpWS",
	urlRemote: "http://ticketonline.malpensashuttle.it/_ws/config.cfm?psw=mxpWS",
	urlLocal: "data/config.js",

	initialize: function(){
		this.url=this.urlRemote;
	},

	fetch: function(options){
		var _self=this;
		options=_.extend({
			timeout: 3000,
			error: function(){
				setTimeout(function(){
				// TODO: show dialog with 'retry' button

				V.dialog.show({
					big: true,
					content: C.getLocalizedString("Non riesco ad accedere ad internet. Vuoi continuare comunque? Continuando le promozioni visualizzate potrebbero non essere più attive. Ricorda che, in ogni caso, per acquistare i biglietti è necessaria una connessione ad internet. Vuoi procedere o ritentare la connessione al server remoto?"),
					buttons: [{
						label: C.getLocalizedString("Continua"),
						callback: function(e){
							if (e) e.preventDefault();
							V.dialog.hide();
							_self.toggleConf();
						}
					}, {
						label: C.getLocalizedString("Riprova"),
						callback: function(e){
							if (e) e.preventDefault();
							V.dialog.hide();
							_self.fetch();
						}
					}]
					
				});
				},1200);
			}
		},options);
		return Backbone.Model.prototype.fetch.call(this,options);
	},

	toggleConf: function(){
		this.url=this.urlLocal;
		this.fetch();
	}
});

/* scarica l'html che descrive le fermate, c'è un fallback hardcodato */
var DeparturesDetailsModel=Backbone.Model.extend({
	//_url: "/malpensa_shuttle<%= lang %>/fermate.cfm",
	_url: "http://ticketonline.malpensashuttle.it/<%= lang %>/fermate.cfm",

	defaults: {
		departures_it: '<strong>Malpensa T. 1 per Milano</strong><br />Piano Arrivi - uscita 4<br /><br /><strong>Malp. T.1 per Linate</strong><br />Piano Arrivi Fermata n.20 di fronte uscita 3<br /><br /><strong>Malpensa Terminal 2</strong><br />Di fonte alle porte ingresso arrivi<br /><br /><strong>Milano Fiera</strong><br />Viale Teodorico 50 metri dopo conces. Citroen<br /><br /><strong>Milano Centrale</strong><br />Uscendo dalla stazione andare a sinistra<br /><br /><strong>Cascina Gobba</strong><br />Subito fuori la fermata della metropolitana<br /><br /><strong>Linate</strong><br />Di fronte alle porte ingresso arrivi<br /><br />',
		departures_en: '<strong>Malpensa T. 1 to Milano</strong><br />Arrivals floor - exit n. 4<br /><br /><strong>Malpensa T1 to Linate</strong><br />Bus stop n. 20, in front of exit 3<br /><br /><strong>Malpensa Terminal 2</strong><br />Near the parkings in front of arrival doors<br /><br /><strong>Milano Fiera</strong><br />Viale Teodorico 50 mt after Citroen<br /><br /><strong>Milano Centrale</strong><br />Outside the station - turn left<br /><br /><strong>Cascina Gobba</strong><br />Out of the subway station<br /><br /><strong>Linate</strong><br />in front of arrival doors<br /><br />'
	},

	url: function(){
		if (appLang==DEFAULT_LANGUAGE) return _.template(this._url,{ lang: "" });
		else return _.template(this._url,{ lang: "/_"+appLang });
	},

	parse: function(data){
		return { departures: data };
	},

	fetch: function(){
		var _self=this;
		this._lang=appLang;
		return Backbone.Model.prototype.fetch.call(this,{
			dataType: "html",
			data: { pageType: "mobile" },
			error: function(){
				_self.set({ departures: _self.get("departures_"+appLang) });
			}
		});
	},

	check: function(){
		if (this._lang==appLang && this.has("departures")) return;
		this.fetch();
	}
});

/* scarica l'html che descrive le fermate, c'è un fallback hardcodato */
var TimetableTextModel=Backbone.Model.extend({
	defaults: {
		timetableText_it: '<p class="txt">I pullman Gran Turismo Malpensa Shuttle collegano ogni 20 minuti Milano Stazione Centrale con Malpensa.<br/>I Malpensa Shuttle collegano anche, direttamente, i due aeroporti di Linate e Malpensa e fermano in entrambi i terminal di quest\'ultimo. In occasione di eventi fieristici, tutti i Malpensa Shuttle fermano, a richiesta, alla Fiera di Milano che e\' quindi raggiungibile, comodamente ed economicamente, direttamente dall\'aeroporto di Malpensa</p>',
		timetableText_en: '<p class="txt">The Malpensa Shuttle Coach Buses connect <strong>each 20 minutes</strong> the<strong> Milan Central train station with Malpensa Airport</strong>.<br /><br />The Malpensa Shuttle also connect directly the two <strong>Milan Airports, Linate and Malpensa,</strong> and stop at both Terminal 1 and Terminal 2 of the latter. In the occasion of fair events, all the Malpensa Shuttle stop, on request, at the <strong>Milan Fair</strong>, which therefore is reached, comfortably and cheaply, directly from Malpensa Airport.</p>'
	},

	fetch: function(){
		this._lang=appLang;
		this.set({ timetableText: this.get("timetableText_"+appLang) });
	},

	check: function(){
		if (this._lang==appLang && this.has("timetableText")) return;
		this.fetch();
	}
});

/* scarica l'html dei prezzi, c'è un fallback hardcodato */
var PricesModel=Backbone.Model.extend({
	//_url: "/malpensa_shuttle<%= lang %>/tariffe.cfm",
	_url: "http://ticketonline.malpensashuttle.it/<%= lang %>/tariffe.cfm",
	defaults: {
		prices_it: '<strong>Malpensa - Milano Centrale</strong>:<br />Corsa Semplice (Adulto): 7.50 &euro;<br />Corsa Semplice (Ridotto 2/12 anni): 3.75 &euro;<br />Andata/ritorno: 12.00 &euro;<br /><br /><strong>Malpensa - Linate</strong>:<br />Corsa Semplice (Adulto): 13.00 &euro;<br />Corsa Semplice (Ridotto 2/12 anni): 6.50 &euro;<br />Andata/ritorno: 26.00 &euro;<br /><br /><strong>Malpensa - Fiera</strong>:<br />Corsa Semplice (Adulto): 7.50 &euro;<br />Corsa Semplice (Ridotto 2/12 anni): 3.75 &euro;<br />Andata/ritorno: 12.00 &euro;<br />',
		prices_en: '<strong>Malpensa - Milano Centrale</strong>:<br />One way (Adults): 7.50 &euro;<br />One way (Children 2/12 years): 3.75 &euro;<br />Round trip: 12.00 &euro;<br /><br /><strong>Malpensa - Linate</strong>:<br />One way (Adults): 13.00 &euro;<br />One way (Children 2/12 years): 6.50 &euro;<br />Round trip: 26.00 &euro;<br /><br /><strong>Malpensa - Fiera</strong>:<br />One way (Adults): 7.50 &euro;<br />One way (Children 2/12 years): 3.75 &euro;<br />Round trip: 12.00 &euro;<br />'
	},

	url: function(){
		if (appLang==DEFAULT_LANGUAGE) return _.template(this._url,{ lang: "" });
		else return _.template(this._url,{ lang: "/_"+appLang });
	},

	parse: function(data){
		return { prices: data };
	},

	fetch: function(){
		var _self=this;
		this._lang=appLang;
		return Backbone.Model.prototype.fetch.call(this,{
			dataType: "html",
			data: { pageType: "mobile" },
			error: function(){
				_self.set({ "prices": _self.get("prices_"+appLang) });
			}
		});
	},

	check: function(){
		if (this._lang==appLang && this.has("prices")) return;
		this.fetch();
	}
});

/* scarica i dati del meteo da yahoo. usa la parte html renderizzata da yahoo, solo in inglese.
se serve si può accedere ai dati tramite codici ma la localizzazione è lunga */
var MeteoModel=CommonModel.extend({
	url: "http://weather.yahooapis.com/forecastrss",
	//url: "services/forecastrss",
	defaults: { woeid: "22306432" },

	parse: function(data){
		var $doc=$(data);
		var condition=$doc.find('item >condition');
		var imgsrc=$doc.find('item > description').text().match(/\<img\s*src=["'](.*?)["']/);
		var forecast=[];
		$doc.find('item >forecast').each(function(){
			var $f=$(this);
			forecast.push({
				date: $f.attr("date"),
				condition: $f.attr("code"),
				low: $f.attr("low"),
				high: $f.attr("high")
			});
		});
		return {
			city: $doc.find('location').attr("city"),
			tempUnit: $doc.find('units').attr("temperature"),
			condition: condition.attr("code"),
			imgsrc: imgsrc?imgsrc[1]:"",
			temp: condition.attr("temp"),
			date: condition.attr("date"),
			forecast: forecast
		};
	},

	fetch: function(){
		var options={
			dataType: "xml",
			data: { w: this.get("woeid"), u: "c" },
			success: this.fetchSuccessHandler,
			error: $.proxy(function(m){
				this.fetchFailureHandler(_.extend({},options));
			},this)
		};
		return Backbone.Model.prototype.fetch.call(this,_.extend({},options));
	}
});

/* modella un biglietto,richiede il prezzo ed il codice vidimazione tramite ws.
Salva su webdatabase */
var TicketModel=CommonModel.extend({
	//url: "/malpensa_shuttle/_ws/idVoucher.cfm",
	url: "http://ticketonline.malpensashuttle.it/_ws/idVoucher.cfm",
	//urlPrice: "/malpensa_shuttle/_ws/priceConfig.cfm",
	urlPrice: "http://ticketonline.malpensashuttle.it/_ws/priceConfig.cfm",
	defaults: {
		// occhio che se si mette l'email nulla tra i campi di default bisogna
		// cambiare qualcosa perché defaults non validerebbe più...
		"psw": "mxpWS",
		"id_partenza": null,
		"id_destinazione": null,
		"andata_ritorno": null,
		"and_data": null,
		"and_orario": null,
		"rit_data": null,
		"rit_orario": null,
		"adulti": null,
		"bambini": null,
		"deviceToken": null,
		"voucherDet": null
	} ,

	set: function(vals,options){
		var DATE_REX=/(\d+)\/(\d+)\/(\d+)/;
		if (vals){
			if (vals.and_data) vals.and_data=vals.and_data.replace(DATE_REX,"$3-$2-$1");
			if (vals.rit_data) vals.rit_data=vals.rit_data.replace(DATE_REX,"$3-$2-$1");
		}
		return CommonModel.prototype.set.apply(this,arguments);
	},

	validate: function(attrs,opt){
		var MAIL_REX=/\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i;
		opt=opt||{};
		if (attrs){
			if (attrs.hasOwnProperty("mail") && !MAIL_REX.test(attrs.mail)){
				return ["Email non valida"];
			}
			return; // not validating other single .set()'s
		} else {
			var errors=[], data=this.toJSON(), dateREX=/\d{4}-\d{2}-\d{2}/;
			if (!(data.id_partenza>0) || !(data.id_destinazione>0)){
				errors.push("Partenza o destinazione non validi");
			}
			if ( data.adulti<=0 && data.bambini<=0 ){
				errors.push("Nessun passeggero per il viaggio");
			}
			if (data.andata_ritorno==1 && 
				(!data.rit_data || data.rit_orario==0 || !dateREX.test(data.rit_data))
			){
				errors.push("Data e orario di ritorno non impostati correttamente");
			} else if (!data.and_data || data.and_orario==0 || !dateREX.test(data.and_data)){
				errors.push("Data e orario di andata non impostati correttamente");
			}
			if (opt.fullCheck){
				if (!data.nome || !data.cognome){
					errors.push("I campi nome e cognome non sono compilati correttamente");
				}
				if (!data.mail){
					errors.push("Mail non presente o non valida");
				}
			}
			if (errors.length>0) return errors;
		}
	} ,

	fetchPrice: function(options){
		options=options||{};
		var data={
			psw: this.get("psw"),
			id_partenza: this.get("id_partenza"),
			id_destinazione: this.get("id_destinazione"),
			andata_ritorno: this.get("andata_ritorno"),
			and_data: this.get("and_data"),
			adulti: this.get("adulti") || 0,
			bambini: this.get("bambini") || 0
		};
		if (data.andata_ritorno==1){
			data.rit_data=this.get("rit_data");
		}
		$.extend(options,{
			url: this.urlPrice,
			data: data,
			// fetchFailureHandlerNoCancel may be too restrictive
			error: $.proxy(function(m){
				this.fetchFailureHandler(_.extend({},options));
			},this)
		});
		return Backbone.Model.prototype.fetch.call(this,_.extend({},options));
	},

	fetch: function(options){
		options=options||{};
		options=_.extend(options,{
			data: {
				psw: this.get("psw"),
				orderId: this.get("orderId")
			},
			// fetchFailureHandlerNoCancel may be too restrictive
			error: $.proxy(function(m){
				this.fetchFailureHandler(_.extend({},options));
			},this)
		});
		return Backbone.Model.prototype.fetch.call(this,_.extend({},options));
	},

	//SUBMIT_ORDER_URL: 'http://svilo.tinext.net/malpensa_shuttle/_ws/requestTokenSetefi.cfm',
	SUBMIT_ORDER_URL: 'http://ticketonline.malpensashuttle.it/_ws/requestTokenSetefi.cfm',
	fetchOrderId: function(){
		var paramObj={}, modelObj=this.toJSON(), includeParams=[
			"psw",
			"id_partenza",
			"id_destinazione",
			"andata_ritorno",
			"and_data",
			"and_orario",
			"rit_data",
			"rit_orario",
			"adulti",
			"bambini",
			"nome",
			"cognome",
			"mail",
			"nazione"
		];
		_.each(includeParams,function(v){
			if (!_.isNull(modelObj[v])){
				paramObj[v]=modelObj[v];
			}
		});
		var lineMXPLIN={4:true, 5:true, 6:true};
		paramObj.lang=appLang;
		paramObj.linea=(paramObj.id_partenza in lineMXPLIN || paramObj.id_destinazione in lineMXPLIN)?2:1;
		var _self=this;
		var d=$.Deferred();
		$.ajax({ url: this.SUBMIT_ORDER_URL, data: paramObj, dataType: 'json' }).done(function(data){
			if (!data || !data.id){
				d.reject();
			}
			_self.set({ orderId: data.id },{ silent: true });
			d.resolve();
		}).fail(function(){
			d.reject();
		});
		return d;
	} ,
	//PAYMENT_URL_BASE: "http://svilo.tinext.net/malpensa_shuttle/_ws/paymentUrl.cfm?",
	PAYMENT_URL_BASE: "http://ticketonline.malpensashuttle.it/_ws/paymentUrl.cfm?",
	getPaymentUrl: function(){
		var paramObj = {
			orderId: this.get("orderId"),
			lang: appLang
		};
		return this.PAYMENT_URL_BASE + $.param(paramObj);
	},

	_persistSchema: persistence.define('Ticket',{
		ticket: "JSON",
		date: "DATE"
	}),

	save: function(opt){
		var _self=this;
		var _save=function(){
			try {
				var t=new TicketModel.prototype._persistSchema({
					ticket: _self.toJSON(),
					date: new Date()
				});
				persistence.add(t);
				persistence.flush();
				if (M.ticketCollection){
					M.ticketCollection.add( _.extend(_self.toJSON(),{
						_saveDate: t.date,
						id: t.id
					}) );
				}
			} catch(err){ console.log("Error: "+err); }
			if (opt.complete) opt.complete();
		};
		opt=opt||{};
		C._websqlOk.done(_save);
		try {
			if (C._websqlOk.state() != 'resolved'){
				C.setupWebDB();
			}
		} catch(err){
			console.log(err);
			if (opt.complete) opt.complete();
		}
	} ,

	destroy: function(){
		console.log("destroy called "+ this.id);
		var Tickets=TicketModel.prototype._persistSchema;
		Tickets.load(this.id,function(t){
			if (t){
				persistence.remove(t);
				persistence.flush();
			}
		});
	}
});

var TicketCollectionModel=Backbone.Collection.extend({
	model: TicketModel,

	fetch: function(){
		var _self=this;
		C._websqlOk.done(function(){
			var Tickets=TicketModel.prototype._persistSchema;
			var models=[];
			Tickets.all().order("date",true).list(null,function(results){
				_.each(results,function(item){
					models.push(_.extend(item.ticket,{
						_saveDate: item.date,
						id: item.id
					}));
				});
				_self.reset(models);
			});
		});
		if (C._websqlOk.state()!='resolved'){
			C.setupWebDB();
		}
	}
});

/* recupera la lista di possibili date di partenza dati i luoghi di partenza, destinazione e la data */
var DepartureDateModel=CommonModel.extend({
	EMPTY_ID: "0",
	//url: "/malpensa_shuttle/_ws/dateConfig.cfm",
	url: "http://ticketonline.malpensashuttle.it/_ws/dateConfig.cfm",
	defaults: {
		psw: "mxpWS",
		id_partenza: null,
		id_destinazione: null,
		dataViaggio: null
	},

	validate: function(attrs){
		attrs=attrs||{};
		if (this.id===this.EMPTY_ID) return;
		var checkProp=["id_partenza","id_destinazione","dataViaggio"], valid=true;
		for (var n in checkProp){
			if ( !attrs[checkProp[n]] && !this.get(checkProp[n]) ){
				valid=false; break;
			}
		}
		if (!valid) return "Error";
	},

	set: function(vals,options){
		var DATE_REX=/(\d+)\/(\d+)\/(\d+)/;
		if (vals && vals.dataViaggio){
			vals.dataViaggio=vals.dataViaggio.replace(DATE_REX,"$3-$2-$1");
		}
		return CommonModel.prototype.set.apply(this,arguments);
	},

	fetch: function(){
		if ( this.validate() || !(this.get("id_partenza")>0) || !(this.get("id_destinazione")>0) ){
			console.log("Error! invalid travel date model");
			this.set({ listTime: [] });
			return;
		}
		options={
			data: {
				psw: this.get("psw"),
				id_partenza: this.get("id_partenza"),
				id_destinazione: this.get("id_destinazione"),
				dataViaggio: this.get("dataViaggio")
			},
			// fetchFailureHandlerNoCancel may be too restrictive
			error: $.proxy(function(m){
				this.fetchFailureHandler(_.extend({},options));
			},this)
		};
		return Backbone.Model.prototype.fetch.call(this,_.extend({},options));
	}
});

/* cache degli orari, dati partenza, destinazione e data */
var DepartureDatesCache=Backbone.Collection.extend({ model: DepartureDateModel });

/* contiene i dati che modellano la mappa */
var MapDataModel=CommonModel.extend({
	url: "services/geoData.js",

	defaults: {
		defaultLocation: { lat: 45.630606, lng: 8.728111 }
	},

	fetch: function(options){
		options=_.extend(options||{},{
			error: $.proxy(function(m){
				this.fetchFailureHandler(_.extend({},options));
			},this)
		});
		return Backbone.Model.prototype.fetch.call(this,_.extend({},options));
	}
});

var UserPositionModel=CommonModel.extend({
	GPS_LOG_FREQUENCY: 2000,
	MIN_GPS_ACCURACY: 120,
	MIN_GPS_DISTANCE: 10, //meters
	gpsTimestampCf: 1,
	_watchId: null,
	_gpsTimestampChecked: false,

	watch: function(){
		var _self=this;
		if (!navigator.geolocation){
			throw new Error("No geolocation capabilities");
		}
		this._watchId=navigator.geolocation.watchPosition(
			$.proxy(this.setUserPosition,this),
			function(err){},
			{
				enableHighAccuracy: true,
				maximumAge: 0,
				frequency: this.GPS_LOG_FREQUENCY
			}
		);
	},

	clearWatch: function(){
		try {
			if (this._watchId!=null){
				navigator.geolocation.clearWatch(this._watchId);
			}
		}catch(err){}
		try {
			navigator.geolocation.stop();
		}catch(err){}
		this._watchId=null;
		this.trigger("destroy");
	},

	isWatching: function(){
		return this._watchId!=null?true:false
	},

	setUserPosition: function(data){
		if (!data){
			//todo
			return;
		}
		// data may be readonly
		data=_.extend({},data);
		if (!this._gpsTimestampChecked && data.timestamp){
			if ((new Date().getTime()-data.timestamp)>Math.pow(2,32)){
				this.gpsTimestampCf=1000;
			}
			this._gpsTimestampChecked=true;
		}
		if (data.timestamp){
			// iPhone/iOS fix
			data.timestamp*=this.gpsTimestampCf;
		}
		//if (data.coords.accuracy>this.MIN_GPS_ACCURACY) return; // this point is garbage
		var coords, dist;
		if ( (coords=this.coords())!=null ){
			dist=this.distance(
				coords.latitude, coords.longitude,
				data.coords.latitude, data.coords.longitude
			);
			//if (dist<(this.MIN_GPS_DISTANCE/1000)) return; // filter on mindist
		}
		this.set({ coords: _.extend({},data.coords), timestamp: data.timestamp });
	},

	coords: function(){
		var c=this.get("coords");
		return c?_.extend({},c):c;
	},

	distance: function(lat1,lon1,lat2,lon2){
		var R = 6371;
		var dLat = this.toRad(lat2-lat1);
		var dLon = this.toRad(lon2-lon1);
		var a = Math.sin(dLat/2) * Math.sin(dLat/2) +
			Math.cos(this.toRad(lat1)) * Math.cos(this.toRad(lat2)) *
			Math.sin(dLon/2) * Math.sin(dLon/2);
		var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
		var d = R * c;
		return d;
	},

	toRad: function(deg){
	        return deg*Math.PI/180;
	}
});

/******************************************************************************

					VIEWS

******************************************************************************/
/* view di base estesa da tutte le altre */
var CommonView=Backbone.View.extend({
	localize: function($el,force){
		if (appLang==DEFAULT_LANGUAGE && !force) return;
		$el.find(".i18n").html(function(i,t){
			return C.getLocalizedString(t);
		});
	},

	formatDate: function(dt,outputFormat){
		return $.mobiscroll.formatDate(outputFormat, dt, $.mobiscroll.i18n[appLang]);
	}
});

var DialogView=CommonView.extend({
	tagName: "div",
	className: "mydialog ui-loader ui-overlay-shadow ui-body-a ui-corner-all",
	template: _.template('<% if (loading){ %><span class="ui-icon ui-icon-loading spin"></span><% }; %><%= content %><% if (buttons.length>0){ %><div data-inline="true"><% _.each(buttons, function(bt,n){ %><a class="mydialogButton<%= n %>" data-role="button" href="<%= bt.href||"#" %>" class="mydialog-btn"><%= bt.label %></a><% }); %></div><% }; %>'),
	bgMask: '<div class="bgmask-dialog"></div>',

	initialize: function(){
		this.mask=$(this.bgMask);
	},

	show: function(opt){
		if (typeof(device) != "undefined") {
			opt.buttons = opt.buttons || [];
			var buttonLabels = _.pluck(opt.buttons, 'label');
			if (buttonLabels.length == 0) {
				buttonLabels = null;
			}
			var cancelCallback = opt.cancelIndex ? opt.buttons[opt.cancelIndex].callback : null;

			deviceReady.done(function() {
				navigator.notification.confirm(opt.content, function(index) {
					console.log("confirm index " + index);
					if (index >= 1 && opt.buttons[index - 1] && opt.buttons[index - 1].callback) {
						opt.buttons[index - 1].callback();
					} else if (!index && cancelCallback) {
						cancelCallback();
					}
				}, "Confirm", buttonLabels);
			});
			return;
		}
		var defaultValues={ loading: false, content: "", buttons: [] }, n;
		opt=opt||{};
		this.remove();
		this.mask.remove();
		this.mask.appendTo("body").css({ height: $.mobile && $.mobile.activePage ?
			$.mobile.activePage.height():$("body").height() });
		this.$el.empty().html( this.template( _.extend({},defaultValues,opt) ) )
			.toggleClass("big-dialog",!!opt.big)
			.appendTo("body").css({
				display: "block",
				top: (this.$el.css('position')==='fixed'?0:$(window).scrollTop())+80
			}).trigger("create");
		if (opt.buttons){
			for(n=0;n<opt.buttons.length;n++){
				if (!_.isFunction(opt.buttons[n].callback)) continue;
				this.$el.find(".mydialogButton"+n).on("click",opt.buttons[n].callback);
			}
		}

	},

	alert: function(msg,callback){
		var _self=this;
		if (typeof(device) != "undefined") {
			deviceReady.done(function() {
				navigator.notification.alert(msg, callback);
			});
			return;
		}
		this.show({
			content: msg.replace(/\n/g, "<br/>"),
			big: true,
			buttons: [{
				label: "Ok",
				callback: function(e){
					e.preventDefault();
					e.stopPropagation();
					_self.hide();
					if (callback) callback();
				}
			}]
		});
        } ,

	confirm: function(msg,success,cancel){
		var _self=this;
		if (typeof(device) != "undefined") {
			deviceReady.done(function() {
				navigator.notification.confirm(msg, function(index) {
					console.log("confirm index " + index);
					if (!index || index == 2) {
						if (cancel) cancel();
					} else {
						if (success) success();
					}
				}, "Confirm", [C.getLocalizedString("Ok"), C.getLocalizedString("Annulla")]);
			});
			return;
		}
		this.show({
			content: msg.replace(/\n/g, "<br/>"),
			big: true,
			buttons: [{
				label: C.getLocalizedString("Ok"),
				callback: function(e){
					e.preventDefault(); _self.hide();
					if (success) success();
				}
			}, {
				label: C.getLocalizedString("Annulla"),
				callback: function(e){
					e.preventDefault(); _self.hide();
					if (cancel) cancel();
				}
			}]
		});
	} ,

	hide: function(){
		this.remove();
		this.mask.remove();
	}
});

var StandardSelectView=CommonView.extend({
	template: _.template('<% _.each(list,function(v){ %><option value="<%= v %>"><%= v %></option><% }); %>'),
	
	render: function(){
		this.$el.html( this.template(this.model.toJSON()) );
		if (this.options.hasOwnProperty("value")){
			this.$el.val(this.options.value);
		}
		this.$el.selectmenu("refresh");
	}
});

/* biglietti veloci */
var DefaultTicketView=CommonView.extend({
	template: _.template('<li data-role="list-divider" class="ui-corner-top"><span class="i18n">Biglietto veloce</span></li><% var view=this; _.each([listTariffeHomeMXP_Centrale,listTariffeHomeMXP_Linate],function(t){ %><li><a href="#ticketPlanner?st=<%= t.id_partenza %>&en=<%= t.id_destinazione %>"><h3><%= view.lookupLocation(t.id_partenza) %> - <%= view.lookupLocation(t.id_destinazione) %></h3><p><span class="i18n">Sola andata</span>: <%= (t.prezzo_adulto/100).toFixed(2)+" €" %> / <span class="i18n">Andata e ritorno</span>: <%= (t.prezzo_adultoAR/100).toFixed(2)+" €" %></p></a></li><% }); %>'),

	initialize: function(){
		this.model.on("change",this.render,this);
		if ( !_.isEmpty(this.model.toJSON()) ){
			this.render();
		}
	},

	lookupLocation: function(id){
		return M.conf.get("listDest")[id] || "N/A";
	},

	render: function(){
		this.$el.parents(":jqmData(role='page')").page()
			.end()
			.html( this.template(this.model.toJSON()) ).listview("refresh");
		this.localize(this.$el);
		return this;
	}
});

/* promozioni */
var PromoView=CommonView.extend({
	template: _.template('<% var view=this; _.each(promos,function(t){ %><div data-role="collapsible"><h3><%= view.lookupLocation(t.id_partenza) %> - <%= view.lookupLocation(t.id_destinazione) %></h3><p><span class="i18n">Per il periodo</span>: <span class="i18n">dal</span> <%= view.formatDate(t.DT_DataStart) %>, <span class="i18n">al</span> <%= view.formatDate(t.DT_DataEnd) %><br/><span class="i18n">Tariffa (adulto)</span>: <%= (t.prezzo_adulto/100).toFixed(2)+" €" %>, <span class="i18n">tariffa (bambino 2/12 anni)</span>: <%= (t.prezzo_bambino/100).toFixed(2)+" €" %><br/><span class="i18n">Per viaggi dal</span> <%= view.formatDate(t.DT_DataStartViaggio) %> <span class="i18n">al</span> <%= view.formatDate(t.DT_DataEndViaggio) %></p><a data-role="button" href="#ticketPlanner?st=<%= t.id_partenza %>&en=<%= t.id_destinazione %>"><span class="i18n">Acquista</span></a></div><% }); %><% if (promos.length==0){ %><div class="details"><span class="i18n">Non ci sono promozioni attive in questo momento</span>.</div><% }; %>'),

	initialize: function(){
		this.model.on("change",this.render,this);
		if (this.model.has("promos")){
			this.render();
		}
	},

	lookupLocation: function(id){
		return M.conf.get("listDest")[id] || "N/A";
	},
	formatDate: function(dt){
		if (!dt) return "N/A";
		return CommonView.prototype.formatDate.call(this,
			new Date( (dt||"").replace(/-/g,"/") ),"DD, dd/mm/yy"
		);
	},

	render: function(){
		this.$el.html( this.template(this.model.toJSON()) );
		this.localize(this.$el);
		this.$el.parents(":jqmData(role='page')")
			.page().trigger("pagecreate");
		var promos=this.model.get("promos");
		if (promos instanceof Array){
			$("#index .promoCnt").text(promos.length);
		}
		return this;
	}
});

/* pagina dettaglio html */
var HTMLDetailView=CommonView.extend({
	template: _.template('<%= html %>'),

	initialize: function(){
		this.model.on("change:"+this.options.modelProperty,this.render,this);
	},

	render: function(){
		var obj={ html: this.model.toJSON()[this.options.modelProperty] };
		this.$el.html( this.template(obj) );
		return this;
	}
});

/* pagina dettaglio "meteo" */
var MeteoView=CommonView.extend({
	template: _.template('<% var view=this; %><div class="title">Yahoo! Weather - <%= city %></div><div class="current"><img src="<%= imgsrc %>"/><br/><span class="i18n title">Condizioni attuali</span>:<br/><span class="i18n">yweather:<%= condition %></span>, <%= temp %> <%= tempUnit %></div><div class="forecast"><span class="i18n title">Previsioni</span>:<br/><% _.each(forecast,function(f){ %><%= view.formatDate(f.date) %> - <span class="i18n">yweather:<%= f.condition %></span>. <span class="i18n">Massima</span>: <%= f.high %> <%= tempUnit %>, <span class="i18n">Minima</span>: <%= f.low %> <%= tempUnit %><br/><% }); %></div>'),

	events: {
		"click a": "inAppBrowserOpen"
	} ,


	initialize: function(){
		this.model.on("change",this.render,this);
	},

	formatDate: function(txtDt){
		return CommonView.prototype.formatDate.call(this,new Date(txtDt),"DD, dd/mm/yy");
	},

	inAppBrowserOpen: function(e){
		e.preventDefault();
		e.stopPropagation();
		window.open($(e.currentTarget).attr("href"),'_blank','location=yes');
	},
	

	render: function(){
		this.$el.html( this.template(this.model.toJSON()) );
		this.localize(this.$el,true);
		this.$("[data-position='fixed']").fixedtoolbar('show');
		return this;
	}
});

/* select box partenze/arrivi con logica per gli onchange */
var BusStopSelectionView=CommonView.extend({
	template: _.template('<option value="0" selected>- - -</option><% _.each(listDest,function(v,k){ %><option value="<%= k %>"><%= v %></option><% }); %>'),

	events: {
		"change": "valueChanged"
	} ,

	initialize: function(){
		if (!this.options.isArrival){
			this.model.on("change:listDest", this.render,this);
			if ( this.model.has('listDest') ){
				this.render();
			}
		} else {
			if (this.options.observe){
				this.options.observe.on("valueChanged", this.observedChanged, this);
			}
		}
	},

	render: function(v){
		var method="enable";
		if (!this.options.isArrival){
			this.$el.html( this.template(this.model.toJSON()) );
		} else {
			if (v==null) return; /*mhm?*/
			var paths=this.model.get("listTuple");
			if (!paths) return; /*mmmmmmmmmmmhm*/
			var validDest=_.pluck(
				_.select(paths,function(o){ return o[0]==v; }), 1
			);
			var listDest={};
			_.each(this.model.get("listDest"), function(ov,ok){
				if (_.indexOf(validDest,+ok)!=-1) listDest[ok]=ov;
			});
			if ($.isEmptyObject(listDest)){
				method="disable";
			}
			var data={ listDest: listDest };
			this.$el.html( this.template(data) );
		}
		this.$el.parents(":jqmData(role='page')").page()
			.end().selectmenu("refresh").selectmenu(method);
		return this;
	} ,

	valueChanged: function(e){
		var val=$(e.currentTarget).val();
		this.trigger("valueChanged",val);
	} ,

	observedChanged: function(val){
		this.render(val);
	} ,

	setValue: function(opt){
		if (this.$el.val()==opt) return;
		this.$el.val(opt).trigger("change").selectmenu("refresh");
	}
});

/* select box con gli orari */
var TimeSelectionView=CommonView.extend({
	template: _.template('<option value="0" selected>- - -</option><% _.each(listTime,function(v,k){ %><option value="<%= v %>"><%= v %></option><% }); %>'),

	initialize: function(){
		this.model.on("change:listTime",function(model){
			if (model.id===this.options.target) this.render();
		},this);
	} ,

	render: function(v){
		if (!this.options.target) return;
		var modelInstance=this.model.get(this.options.target);
		if (!modelInstance) return;
		var method="enable";
		modelInstance=modelInstance.toJSON();
		if (!_.isArray(modelInstance.listTime)){
			this.$el.html( this.template({ listTime: [] }) );
			if (modelInstance.listTime && modelInstance.listTime.error){
				V.dialog.alert(C.getLocalizedString(
					modelInstance.listTime.error=="noServizioFiera"?
					"Il servizio fiera non è attivo per la data selezionata"
					:"Non ci sono corse per la data specificata"
				));
			}
			method="disable";
		} else {
			this.$el.html( this.template(modelInstance) );
			if (modelInstance.listTime.length==0){
				method="disable";
			}
		}
		this.$el.parents(":jqmData(role='page')").page()
			.end().selectmenu("refresh").selectmenu(method);
	}
});

/* logica form ticket selection */
var TicketPlannerView=CommonView.extend({
	events: {
		"submit": "ticketSubmitted",
		"change #typeSingle, #typeRoundTrip": "changeTicketType",
		"change #dateDeparture": "checkTime",
		"change #dateReturn": "checkTimeReturn"
	},

	initialize: function(){
		$("#ticketPlanner").page();
		this.$(":jqmData(role=mobiscroll)").mobiscroll("destroy").mobiscroll({
			preset: "date",
			lang: appLang
		});
		this.changeTicketType();
		if (this.options.observeDestination){
			this.options.observeDestination.on("valueChanged", this.checkTime, this);
		}
	},

	changeTicketType: function(){
		var val=this.$el.find('input:radio[name=andata_ritorno]:checked').val();
		var action=(val!=1)?"disable":"enable";
		$("#dateReturn").mobiscroll(action);
		$("#timeReturn").selectmenu(action);
		this.checkTime(true);
		/*if (val!=1){
			$("#ticketSelection .isRoundTrip").slideUp();
		} else {
			$("#ticketSelection .isRoundTrip").slideDown();
		}*/
	},

	checkTimeReturn: function(){ this.checkTime(true); },

	checkTime: function(skipDeparture){
		var formData=this.$el.serializeArray();
		var setData={}, modelId, travelDate, tmp;
		$.each(formData,function(k,v){
			setData[v.name]=v.value;
		});
		if (skipDeparture!==true){
			if ( !(setData.id_partenza>0) || !(setData.id_destinazione>0) ||
				!setData.and_data
			){
				V.departureTime.options.target=DepartureDateModel.prototype.EMPTY_ID;
				V.departureTime.render();
			} else {
				modelId=[setData.id_partenza,setData.id_destinazione,setData.and_data]
					.join("|");
				V.departureTime.options.target=modelId;
				travelDate=M.travelDateCache.get(modelId);
				if (!travelDate){
					tmp=new DepartureDateModel({
						id: modelId, id_partenza: setData.id_partenza,
						id_destinazione: setData.id_destinazione,
						dataViaggio: setData.and_data
					});
					M.travelDateCache.add(tmp);
					// the following setTimeout fixes a strange bug in my phone...
					setTimeout(function(){ tmp.fetch(); },50);
				} else {
					V.departureTime.render();
				}
			}
		}

		var travelType=this.$el.find('input:radio[name=andata_ritorno]:checked').val();
		if (travelType!=1) return;
		if ( !(setData.id_partenza>0) || !(setData.id_destinazione>0) || !setData.rit_data ){
			V.returnTime.options.target=DepartureDateModel.prototype.EMPTY_ID;
			V.returnTime.render();
		} else {
			modelId=[setData.id_destinazione,setData.id_partenza,setData.rit_data]
				.join("|");
			V.returnTime.options.target=modelId;
			travelDate=M.travelDateCache.get(modelId);
			if (!travelDate){
				tmp=new DepartureDateModel({
					id: modelId, id_partenza: setData.id_destinazione,
					id_destinazione: setData.id_partenza,
					dataViaggio: setData.rit_data
				});
				M.travelDateCache.add(tmp);
				// the following setTimeout fixes a strange bug in my phone...
				setTimeout(function(){ tmp.fetch(); },50);
			} else {
				V.returnTime.render();
			}
		}
	} ,

	ticketSubmitted: function(e){
		e.preventDefault();
		var errors;
		var formObj={ // these are required because, when disabled, they're not returned
			// by serializeArray
			rit_data: null, rit_orario: null
		};
		$.each(this.$el.serializeArray(),function(k,v){
			formObj[v.name]=v.value;
		});
		if (!M.ticket){
			M.ticket=new TicketModel();
			V.ticketSummary=new TicketSummaryView({
				el: $("#ticketConfirm"), model: M.ticket 
			});
			if (window.localStorage){
				$("#userEmail").val( localStorage.getItem("userEmail") || "" );
				$("#userName").val( localStorage.getItem("userName")|| "" );
				$("#userSurname").val( localStorage.getItem("userSurname") || "" );
				$("#userCountry").val( localStorage.getItem("userCountry") || "" );
			}
		}
		M.ticket.set( _.extend(formObj, {prices:false}) );
		if ( (errors=M.ticket.validate()) ){
			if (_.isArray(errors)){
				V.dialog.alert( _.map(errors,function(err){
					return C.getLocalizedString(err);	
				}).join("\n") );
			}
			return;
		}
		M.ticket.fetchPrice();
		$.mobile.changePage("#ticketConfirm");
	}
});

/* riepilogo ticket */
var TicketSummaryView=CommonView.extend({
	template: _.template(['<% var view=this; %><div class="title i18n">Riepilogo biglietto</div>',
		'<div class="item"><div class="field"><div class="label"><span class="i18n">Partenza</span>: </div><div class="value"><%= view.lookupLocation(id_partenza) %></div><br clear="all"/></div>',
		'<div class="field"><div class="label"><span class="i18n">Arrivo</span>: </div><div class="value"><%= view.lookupLocation(id_destinazione) %></div><br clear="all"/></div>',
		'<div class="field"><div class="label"><span class="i18n">Data andata</span>: </div><div class="value"><%= view.formatDate(and_data) %></div><br clear="all"/></div>',
		'<div class="field"><div class="label"><span class="i18n">Orario</span>: </div><div class="value"><%= and_orario %></div><br clear="all"/></div>',
		'<% if (rit_data && rit_orario){ %><div class="field"><div class="label"><span class="i18n">Data ritorno</span>: </div><div class="value"><%= view.formatDate(rit_data) %></div><br clear="all"/></div>',
		'<div class="field"><div class="label"><span class="i18n">Orario</span>: </div><div class="value"><%= rit_orario %></div><br clear="all"/></div><% }; %>',
		'<% if (prices && prices.totale_bambini>0){ %><div class="field"><div class="label"><span class="i18n">Prezzo bambini (2/12 anni)</span>: </div><div class="value price"><%= view.formatCurrency(prices.totale_bambini) %></div><br clear="all"/></div><% };',
		' if (prices && prices.totale_adulti>0){ %><div class="field"><div class="label"><span class="i18n">Prezzo adulti</span>: </div><div class="value price"><%= view.formatCurrency(prices.totale_adulti) %></div><br clear="all"/></div><% }; %>',
		'<% if (prices){ %><div class="field"><div class="label"><span class="i18n">Totale</span>: </div><div class="value price"><%= view.formatCurrency(prices.totale) %></div><br clear="all"/></div><% }; %>'
	].join("")),

	events: {
		"click .buyTicket": "buyTicket"
	} ,

	initialize: function(){
		this.model.on("change",this.render,this);
	} ,

	lookupLocation: function(id){
		return M.conf.get("listDest")[id] || "N/A";
	},
	formatDate: function(dt){
		if (!dt) return "N/A";
		return CommonView.prototype.formatDate.call(this,
			new Date( (dt||"").replace(/-/g,"/") ),"DD, dd/mm/yy"
		);
	},

	formatCurrency: function(price){
		return (+price/100).toFixed(2)+" €";
	},

	render: function(){
		this.$el.find(".details").html( this.template( this.model.toJSON() ) );
		this.localize(this.$el);
	} ,

	buyTicket: function(){
		var 	formData=this.$el.find("form").serializeArray(),
			setData, errors, setErrors=[], _self=this, model
		;
		$.each(formData,function(k,v){
			setData={};
			setData[v.name]=v.value;
			_self.model.set(setData, { 
				error: function(m,err){ setErrors.push(err); }
			});
		});
		errors=this.model.validate(null,{ fullCheck: true });
		if ( setErrors.length>0 || errors ){
			if (_.isArray(errors)){
				V.dialog.alert(_.map(errors,function(err){
					return C.getLocalizedString(err);
				}).join("\n"));
			} else {
				V.dialog.alert(_.map(setErrors,function(err){
					return C.getLocalizedString(err);
				}).join("\n"));
			}
			return;
		}
		model=this.model.toJSON();
		if (window.localStorage){
			localStorage.setItem("userEmail",model.mail);
			localStorage.setItem("userName",model.nome);
			localStorage.setItem("userSurname",model.cognome);
			localStorage.setItem("userCountry",model.nazione);
		}
		C.startPayment();
	}
});

var TicketDetailView=CommonView.extend({
	template: _.template(['<% var view=this; %><div class="title i18n">Riepilogo biglietto</div>',
		'<div class="item">',
			'<div class="field"><div class="label"><span class="i18n">Partenza</span>: </div><div class="value"><%= view.lookupLocation(id_partenza) %></div><br clear="all"/></div>',
			'<div class="field"><div class="label"><span class="i18n">Arrivo</span>: </div><div class="value"><%= view.lookupLocation(id_destinazione) %></div><br clear="all"/></div>',
			'<div class="field"><div class="label"><span class="i18n">Data andata</span>: </div><div class="value"><%= view.formatDate(and_data) %></div><br clear="all"/></div>',
			'<div class="field"><div class="label"><span class="i18n">Orario</span>: </div><div class="value"><%= and_orario %></div><br clear="all"/></div>',
			'<% if (rit_data && rit_orario){ %><div class="field"><div class="label"><span class="i18n">Data ritorno</span>: </div><div class="value"><%= view.formatDate(rit_data) %></div><br clear="all"/></div>',
			'<div class="field"><div class="label"><span class="i18n">Orario</span>: </div><div class="value"><%= rit_orario %></div><br clear="all"/></div><% }; %>',
			'<% if (bambini>0){ %><div class="field"><div class="label"><span class="i18n">Bambini</span>: </div><div class="value"><%= bambini %></div><br clear="all"/></div>',
			'<% }; if (adulti>0){ %><div class="field"><div class="label"><span class="i18n">Adulti</span>: </div><div class="value"><%= adulti %></div><br clear="all"/></div>',
			'<% }; %><% if (prices){ %><div class="field"><div class="label"><span class="i18n">Totale</span>: </div><div class="value price"><%= view.formatCurrency(prices.totale) %></div><br clear="all"/></div>',
			'<% }; %>',
			'<div class="field"><div class="label"><span class="i18n">Codice biglietto</span>: </div><div class="value highlight"><%= voucherDet.idVoucher %></div><br clear="all"/></div>',
			'<div class="field"><div class="label"><span class="i18n">Nome</span>: </div><div class="value"><%= nome %> <%= cognome %></div><br clear="all"/></div>',
		'</div>'
	].join("")),

	events: {
		"click .delHistoryTicket": "delHistoryTicket"
	},

	initialize: function(){
		this.model.on("change:voucherDet",this.render,this);
	} ,

	setModel: function(model){
		if (this.model) this.model.off("change:voucherDet",this.render);
		this.model=model;
		this.initialize();
	} ,

	render: function(){
		var modelObj=_.extend({
			"nome": "N/A", "cognome": "N/A"
		},this.model.toJSON());
		if (!modelObj.voucherDet){
			this.$el.find(".ticket").html("No ticket");
			return;
		}
		this.$el.find(".ticket").html( this.template(modelObj) );
		this.localize(this.$el);
	} ,

	lookupLocation: function(id){
		return M.conf.get("listDest")[id] || "N/A";
	},

	formatCurrency: function(price){
		return (+price/100).toFixed(2)+" €";
	},
	formatDate: function(dt){
		if (!dt) return "N/A";
		return CommonView.prototype.formatDate.call(this,
			new Date( (dt||"").replace(/-/g,"/") ),"DD, dd/mm/yy"
		);
	},

	delHistoryTicket: function(e){
		var id=$(e.currentTarget).attr("data-params");
		var model=M.ticketCollection.get(id);
		if (model){
			model.destroy();
			M.ticketCollection.remove(model);
		}
	}
});

var TicketListItemView=CommonView.extend({
	tagName: "li",
	template: _.template('<% var view=this; %><a href="#ticketDetail?id=<%= id %>"><h3><%= view.lookupLocation(id_partenza) %> - <%= view.lookupLocation(id_destinazione) %></h3><p><%= view.formatDate(_saveDate,"DD, dd/mm/yy") %> <%= view.formatTime(_saveDate) %>, <%= typeof(prices)!="undefined"?view.formatCurrency(prices.totale):"N/A" %></p></a>'),

	initialize: function(){
		this.model.on("change",this.render,this);
		this.model.on("remove",this.remove,this);
	} ,

	lookupLocation: function(id){
		return M.conf.get("listDest")[id] || "N/A";
	},
	// occhio che è diverso questo formatDate!
	formatDate: function(dt,format){
		if (!dt || !(dt instanceof Date)) return "N/A";
		return CommonView.prototype.formatDate.call(this,dt,format);
	},
	formatTime: function(dt){
		if (!dt || !(dt instanceof Date)) return "N/A";
		return dt.toLocaleTimeString();
	},
	formatCurrency: function(price){
		return (+price/100).toFixed(2)+" €";
	},

	render: function(){
		this.$el.html( this.template(this.model.toJSON()) );
		return this;
	},

	remove: function(){
		this.$el.remove();
	}
});

var TicketCollectionView=CommonView.extend({
	emptyTemplate: _.template('<li><span class="i18n">Nessun biglietto acquistato precedentemente</span></li>'),
	initialize: function(){
		this.model.on("add",this.addOne,this);
		this.model.on("reset",this.addAll,this);
		this.model.on("remove",this.remove,this);
	} ,

	addOne: function(model) {
		var _self=this;
		var view=new TicketListItemView({model: model});
		if (this.model.length<=1){ this.$el.empty(); }
		this.$el.prepend(view.render().el);
		if (this._refreshTimer) clearTimeout(this._refreshTimer);
		this._refreshTimer=setTimeout(function(){ _self.$el.listview("refresh"); },50);
	},

	addAll: function() {
		this.model.each($.proxy(this.addOne,this));
		if (this.model.length==0){
			this.$el.html( this.emptyTemplate() );
			this.localize(this.$el);
			this.$el.listview("refresh");
		}
	},

	remove: function(){
		if (this.model.length==0){
			this.$el.empty().html( this.emptyTemplate() );
			this.localize(this.$el);
			this.$el.listview("refresh");
		}
	}
});

/* select per la selezione di una route dalla lista nella pagina della mappa */
var RouteSelectionView=CommonView.extend({
	template: _.template('<option value="0" selected class="i18n">Tutti i percorsi</option><% _.each(routes,function(v,k){ %><option value="<%= k %>"><%= v.name %></option><% }); %>'),

	events: {
		"change": "valueChanged"
	} ,

	initialize: function(){
		this.model.on("change:routes", this.render, this);
	} ,

	valueChanged: function(e){
		var val=$(e.currentTarget).val();
		this.trigger("valueChanged",val);
	} ,

	val: function(){
		return this.$el.val();
	} ,

	render: function(v){
		this.$el.html( this.template( this.model.toJSON() ) );
		this.localize(this.$el);
		this.$el.parents(":jqmData(role='page')").page()
			.end().selectmenu("refresh");
	}
});

var UserPositionView=CommonView.extend({
	USER_POSITION_MARKER_IMG: "images/userPos.png",
	userPositionMarker: null,

	initialize: function(){
		this.model.on("change",this.render,this);
		this.model.on("destroy",this.destroy,this);
	},
	
	render: function(){
		var pos=this.model.coords(), gposition;
                if (!pos) return;
                if (!this.userPositionMarker){
			this.userPositionMarker=new google.maps.Marker({
				icon: new google.maps.MarkerImage( this.USER_POSITION_MARKER_IMG,
					new google.maps.Size(25,25), new google.maps.Point(0,0),
					new google.maps.Point(12,13)
				)
			});
		}
		gposition=new google.maps.LatLng(pos.latitude,pos.longitude);
		this.userPositionMarker.setOptions({
			map: this.options.mapview.gmap, position: gposition
		});
		this.trigger("change",gposition);
	},

	destroy: function(){
		if (this.userPositionMarker) this.userPositionMarker.setMap(null);
		this.trigger("change",null);
	}
});

var RoutesMapView=CommonView.extend({
	ROUTE_COLOR_MAP: [ "#FF0099","#110099","#33FF00","#FF3300","#33FFCC",
	"#CCFF00","#666666","#9900FF","#006633","#333333" ],
	ROUTE_COLOR_SHADOW: "#000000",

	routesPoly: {},
	_usedRouteColorMap: {},

	getAvailableRouteColor: function(){
		for(var n=0;n<this.ROUTE_COLOR_MAP.length;n++){
			if (!this._usedRouteColorMap[n]) return n;
		}
		return 0;
	} ,

	genRoutePoly: function(id,route){
		var     gpoints=[], n, data=route.data, datalen=data.length,
			filter=false, filterPolicy, color, routeObj, bounds
		;
		if (datalen>1000){
			filter=true;
			filterPolicy=Math.round(datalen/1000);
		}
		bounds=new google.maps.LatLngBounds();
		for(n=0;n<datalen;n++){
			if (filter){
				if ((n%filterPolicy)==0){
					gpoints.push(new google.maps.LatLng(data[n].la,data[n].ln));
					bounds.extend(_.last(gpoints));
				}
			} else {
				gpoints[n]=new google.maps.LatLng(data[n].la,data[n].ln);
				bounds.extend(gpoints[n]);
			}
		}
		color=this.getAvailableRouteColor();
		this._usedRouteColorMap[color]=id;
		routeObj={
			p: new google.maps.Polyline({
				path: gpoints,
				strokeColor: this.ROUTE_COLOR_MAP[color],
				strokeWeight: 3,
				clickable: false,
				zIndex: 1
			}),
			pshad: new google.maps.Polyline({
				path: gpoints,
				strokeColor: this.ROUTE_COLOR_SHADOW,
				strokeWeight: 9,
				strokeOpacity: 0.7,
				clickable: false,
				zIndex: 0
			}),
			e: null,
			bounds: bounds
		};
		routeObj.p._routeid=id;
		routeObj.pshad._routeid=id;
		return routeObj;
	},

	detachRoutes: function(routes,routeIds){
		var k, id, filteredRoutesIds=_.difference( _.keys(routes),routeIds);
		for(k in filteredRoutesIds){
			id=filteredRoutesIds[k];
			if (this.routesPoly[id]){
				this.routesPoly[id].p.setMap(null);
				this.routesPoly[id].pshad.setMap(null);
				this.routesPoly[id]=null;
			}
		}
		_.each(this._usedRouteColorMap,function(v,k){
			if ( _.include(filteredRoutesIds,v) ) delete this._usedRouteColorMap[k];
		},this);
	},

	filterRoutes: function(routes){
		var id, routeIds, filter=V.routeSelection.val();
		routeIds=_.keys(routes);
		return _.filter(routeIds,function(v){
			return (filter=="0" || filter==v);
			
		});
	} ,

	render: function(){
		var k, id, routes=this.model.get("routes"), filteredRoutesIds, bounds;
		bounds=new google.maps.LatLngBounds();
		filteredRoutesIds=this.filterRoutes(routes);
		for(k in filteredRoutesIds){
			id=filteredRoutesIds[k];
			if (!this.routesPoly[id]){
				if (routes[id] && routes[id].data){
					this.routesPoly[id]=this.genRoutePoly(id,routes[id]);
				}
			}
			if (!this.routesPoly[id].bounds.isEmpty()){
				bounds.union(this.routesPoly[id].bounds);
			}
			if (this.routesPoly[id]){
				this.routesPoly[id].p.setMap(this.options.mapview.gmap);
				this.routesPoly[id].pshad.setMap(this.options.mapview.gmap);
			}
		}
		this.detachRoutes(routes,filteredRoutesIds);
		this.trigger("change",bounds);
	} 
});

var POISMapView=CommonView.extend({
	POI_MARKER_IMG: "images/poi.png",
	pois: {},

	render: function(){
		var id, pois=this.model.get("pois"), bounds, _self=this;
		bounds=new google.maps.LatLngBounds();
		for(id in pois){
			if (!this.pois[id]){
				var img;
				if (pois[id].type) img="images/"+pois[id].type+".png";
				else img=this.POI_MARKER_IMG;
				this.pois[id]={
					marker: new google.maps.Marker({
						icon: new google.maps.MarkerImage(img,
							new google.maps.Size(30,32),
							new google.maps.Point(0,0),
							new google.maps.Point(24,32)
						),
						clickable: true,
						position: new google.maps.LatLng(pois[id].la,pois[id].ln)
					})
				};
				this.pois[id].e=google.maps.event.addListener(
					this.pois[id].marker,"click",
					function(){
						_self.poiClicked(this);
					}
				);
				this.pois[id].marker._poiid=id;
			}
			this.pois[id].marker.setMap(this.options.mapview.gmap);
			bounds.extend(this.pois[id].marker.getPosition());
		}
		this.trigger("change",bounds);
	},

	poiClicked: function(poi){
		var poi=this.model.get("pois")[poi._poiid];
		if (!poi) return;
		V.dialog.alert(poi.name);
	}
});

/* vista "mappa", supporta routes e pois */
var MapView=CommonView.extend({
	ROUTES: 1,
	POIS: 2,
	USER_POSITION: 4,
	ALL: -1,

	events: {
		"click .centerBt": "manageCenter",
		"click .gpsBt": "manageGPS"
	},

	initialize: function(){
		V.routeSelection=new RouteSelectionView({ model: this.model, el: $("#routeSelection") });
		V.routeSelection.on("valueChanged", function(){
			this.render(null,{ mode: this.ROUTES });
		}, this);

		V.routesView=new RoutesMapView({ model: this.model, mapview: this });
		V.routesView.on("change",function(bounds){
			this._routesBounds=bounds;
			if ( (this.options.mode & this.ROUTES) == this.ROUTES ){
				this.setBounds();
			}
		},this);

		V.poisView=new POISMapView({ model: this.model, mapview: this });
		V.poisView.on("change",function(bounds){
			this._poisBounds=bounds;
			if ( (this.options.mode & this.POIS) == this.POIS ){
				this.setBounds();
			}
		},this);

		if (!M.userPosition){
			M.userPosition=new UserPositionModel();
		}
		V.userPositionView=new UserPositionView({ model: M.userPosition, mapview: this });
		V.userPositionView.on("change",function(point){
			this._userPosition=point;
			if ( (this.options.mode & this.USER_POSITION) == this.USER_POSITION){
				this.setBounds();
			}
		},this);

		this.model.on("change",this.render, this);
		this.setMapHeight();
		C.gmapsLoaded.done( $.proxy(function(){
			if (C._mapShown.state()=='resolved') this.setup();
			else C._mapShown.done( $.proxy(this.setup, this) );
		},this) );
		var _self=this;
		$(window).on("orientationchange resize",function(e){
			if (_self._orientationChangeTimer){
				clearTimeout(_self._orientationChangeTimer);
			}
			_self._orientationChangeTimer=setTimeout(function(){
				_self._orientationChangeTimer=null;
				if ( C._mapShown.state()=='resolved' ){
					_self.setMapHeight();
				}
				$("[data-position='fixed']").fixedtoolbar('show');
			},600);
			return true;
		});
	} ,

	setup: function(){
		var def=this.model.get("defaultLocation");
		var myOptions = {
			zoom: 13,
			mapTypeId: google.maps.MapTypeId.SATELLITE,
			center: new google.maps.LatLng(def.lat,def.lng)
		};
		this.gmap=new google.maps.Map(this.$el.find("#gmap")[0], myOptions);
		google.maps.event.addListenerOnce( this.gmap, "idle", $.proxy(function(){
			if (C._mapShown.state()!='resolved'){
				// OH NOOOOOOES!!!!1111
				// that fucking user hit the back button before the map was fully loaded.
				// This is very bad news, so let's use the deferred to fix things up for
				// our stupid user
				C._mapShown.done( $.proxy(function(){
					google.maps.event.trigger(this.gmap,"resize");
				},this) );
			}
		},this) );
		if (this._dirtystatus) this.render();
	} ,

	setMapHeight: function(){
		var     hdim=0, winH, $hasRouteFilter=$("#routeFilter"),
			$hasFooter=$("#map .ui-footer")
		;
		if ($hasRouteFilter.is(":visible")){
			hdim+=$hasRouteFilter.outerHeight();
		}
		if ($hasFooter.is(":visible")){
			hdim+=$hasFooter.outerHeight();
		}
		hdim += 2 + $("#map .ui-header").outerHeight();
		winH=(typeof(window.innerHeight)!='undefined')?
			window.innerHeight
			:(typeof(document.documentElement)!='undefined' &&
			typeof(document.documentElement.clientHeight)!='undefined')?
				document.documentElement.clientHeight
				:$(window).height()
		;
		$("#gmap").css({"width":"100%", "height":(winH-hdim)+"px"});
		this.$("[data-position='fixed']").fixedtoolbar('show');
		if (this.gmap) google.maps.event.trigger(this.gmap,"resize");
	},

	render: function(model,opt){
		if (!this.gmap){
			this._dirtystatus=true;
			return;
		}
		opt=_.extend({ mode: -1 },opt);
		if ( (opt.mode & this.options.mode & this.ROUTES) == this.ROUTES ){
			V.routesView.render();
		}
		if ( (opt.mode & this.options.mode & this.POIS) == this.POIS ){
			V.poisView.render();
		}
	} ,

	setBounds: function(){
		if (C._mapShown.state()!='resolved'){
			if (!this._setBoundsScheduled){
				this._setBoundsScheduled=true;
				C._mapShown.done($.proxy(this.setBounds,this));
			}
			return;
		}
		if (this._boundsTimer) clearTimeout(this._boundsTimer);
		this._boundsTimer=setTimeout( $.proxy( function(){
			this._boundsTimer=null;
			this._setBoundsScheduled=false;
			var bounds=new google.maps.LatLngBounds();
			if ( 	(this.options.mode & this.ROUTES) == this.ROUTES &&
				this._routesBounds && !this._routesBounds.isEmpty()
			){
				bounds.union(this._routesBounds);
			}
			if ( 	(this.options.mode & this.POIS) == this.POIS &&
				this._poisBounds && !this._poisBounds.isEmpty()
			){
				bounds.union(this._poisBounds);
			}
			if ( 	(this.options.mode & this.USER_POSITION) == this.USER_POSITION &&
				this._userPosition 
			){
				bounds.extend(this._userPosition);
			}
			if (!bounds.isEmpty()){
				var span=bounds.toSpan();
				if (span.lat()==0 && span.lng()==0){
					this.gmap.setCenter(bounds.getCenter());
				} else {
					this.gmap.fitBounds(bounds);
				}
			}
		}, this ), 100 );
	},

	manageCenter: function(e){
		var bt=$(e.currentTarget);
		setTimeout(function(){ bt.removeClass("ui-btn-active"); },100);
		var _self=this;
		var opt={
			content: C.getLocalizedString("Scegli su cosa vuoi centrare la mappa"),
			big: true,
			buttons: [{
				label: C.getLocalizedString("Percorsi / POI"),
				callback: function(e){
					_self.options.mode=_self.ROUTES | _self.POIS;
					_self.setBounds();
					if (e) e.preventDefault();
					V.dialog.hide();
				}
			},{
				label: C.getLocalizedString("Tua posizione"),
				callback: function(e){
					_self.options.mode=_self.USER_POSITION;
					_self.setBounds();
					if (e) e.preventDefault();
					V.dialog.hide();
				}
			},{
				label: C.getLocalizedString("Tutto"),
				callback: function(e){
					_self.options.mode=_self.ALL;
					_self.setBounds();
					if (e) e.preventDefault();
					V.dialog.hide();
				}
			},{
				label: C.getLocalizedString("Annulla"),
				callback: function(e){
					if (e) e.preventDefault();
					V.dialog.hide();
				}
			}]
		};
		V.dialog.show(opt);
	},

	manageGPS: function(e){
		var bt=$(e.currentTarget);
		setTimeout(function(){ bt.removeClass("ui-btn-active"); },100);
		if (M.userPosition.isWatching()){
			V.dialog.confirm(
				C.getLocalizedString("Il GPS è attualmente attivo. Vuoi spegnerlo?"),
				function(){
					M.userPosition.clearWatch();
				}
			);
		} else {
			V.dialog.confirm(
				C.getLocalizedString("Il GPS è attualmente spento. Vuoi accenderlo?"),
				function(){
					M.userPosition.watch();
				}
			);
		}
	}
});

/******************************************************************************

					CONTROLLERs	

******************************************************************************/
C={
	MAX_GMAP_LOAD_TIMEOUT: 6000,

	_websqlOk: $.Deferred(),
	_initialized: $.Deferred(),

	initialize: function(){
		$("#languageSelection").on("change",C.languageChanged);
		C.getLang();

		M.travelDateCache=new DepartureDatesCache([{
			id: DepartureDateModel.prototype.EMPTY_ID, listTime: []
		}]);

		V.defaultTickets=new DefaultTicketView({
			el: $("#fastTicket .defaultTickets"), model: M.conf
		});
		V.promos=new PromoView({
			el: $("#promo .promos"), model: M.conf
		});
		V.departuresSelect=new BusStopSelectionView({
			el: $("#ticketDeparture"), model: M.conf, isArrival: false
		});
		V.departureTime=new TimeSelectionView({
			el: $("#timeDeparture"), model: M.travelDateCache, target: null
		});
		V.returnTime=new TimeSelectionView({
			el: $("#timeReturn"), model: M.travelDateCache, target: null
		});
		V.arrivalsSelect=new BusStopSelectionView({
			el: $("#ticketArrival"), model: M.conf, isArrival: true,
			observe: V.departuresSelect
		});
		V.ticketLogic=new TicketPlannerView({
			el: $("#ticketSelection"), observeDestination: V.arrivalsSelect
		});
	},

	getLocalizedString: function(key,lookupReverse){
		try {
			var rkey;
			if (lookupReverse){
				rkey=reverseLocalized[key];
			}
			if (rkey===undefined) rkey=key;
			var ret=localizedStrings[rkey];
			if (ret===undefined){
				ret=rkey;
			}
			return ret;
		} catch(err){}
		return key;
	},

	languageChanged: function(){
		var l=$(this).val(), n;
		if (l==appLang) return; // nothing to do
		reverseLocalized=null;
		reverseLocalized={};
		for(n in localizedStrings){
			reverseLocalized[localizedStrings[n]]=n;
		}
		if (l==DEFAULT_LANGUAGE){
			localizedStrings=null;
			$.getScript("data/lang-"+l+".js",function(){
				appLang=l;
				$(":jqmData(role=mobiscroll)").mobiscroll("option", {
					lang: l
				});
				//$(C).trigger("languageChanged");
				C.localize();
			});
			return;
		}
		var loadCompleteDeferred=$.Deferred();
		loadCompleteDeferred.ready=0;
		loadCompleteDeferred.resourceReady=function(){
			this.ready++;
			if (this.ready>=2){
				this.resolve();
			}
		};
		loadCompleteDeferred.done(function(){
			//$(C).trigger("languageChanged");
			C.localize();
		});
		$.ajax({
			url: "data/lang-"+l+".js",
			dataType: "json",
			success: function(data){
				if (!_.isObject(data) || !data._lang){
					V.dialog.alert(C.getLocalizedString("Errore durante l'interpretazione del file di lingua"));
					return;
				}
				localizedStrings=null;
				appLang=l;
				localizedStrings=data;
				loadCompleteDeferred.resourceReady();
			}
		});
		$(":jqmData(role=mobiscroll)").mobiscroll("option", {
			lang: l
		});
		loadCompleteDeferred.resourceReady();
	},

	localize: function(){
		try { localStorage.setItem("appLang",appLang);
		}catch(err){}
		$(".i18n").html(function(i,t){
			return C.getLocalizedString(t,true);
		});
		try {
			$(":jqmData(role=mobiscroll)").mobiscroll("option", {
				lang: appLang
			});
		} catch (err) {
			console.log(err);
		}
		try {
			$("button[type=submit]").button("refresh");
		} catch(err){}
		try {
			$("input[type=radio]").checkboxradio("refresh");
		} catch(err){}
	},

	getLang: function(){
		var l;
		try {
			l=localStorage.getItem("appLang");
			if (l==null){
				l=window.navigator.language.slice(0,2).toLowerCase();
			}
			if (l!=DEFAULT_LANGUAGE){
				if (! (l in AVAILABLE_LANGUAGES)){
					throw new Error("Language unavailable");
				}
			}
			$("#languageSelection").val(l).trigger("change");
		}catch(err){ }
	},

	_loadGMaps: function(){
		var     script = document.createElement("script"),
			rnd=Math.random().toString().slice(2)
		;
		script.type="text/javascript";
		script.src="http://maps.google.com/maps/api/js?sensor=true&rnd="+rnd+"&callback=C._preInitializeGMaps";
		$("body").append(script);
	},

	_preInitializeGMaps: function(stat){
		C._loadingGmaps=false;
		if (stat===false){
			V.dialog.alert(C.getLocalizedString("Non riesco a caricare le mappe di google, verifica che la connessione sia disponibile"));
			$.mobile.changePage("#index");
			return;
		}
		C.gmapsLoaded.resolve();
		clearTimeout(C._preInitWatchdog);
	},

	_checkGmap: function(readyCallback){
		if (!C.gmapsLoaded){
			C.gmapsLoaded=$.Deferred();
		} else if (C.gmapsLoaded.state() == 'resolved'){
			return;
		}
		if (!C._loadingGmaps){
			C._loadingGmaps=true;
			C._loadGMaps();
			C._preInitWatchdog=setTimeout(function(){
				C._preInitializeGMaps(false);
			},C.MAX_GMAP_LOAD_TIMEOUT);
		}
	},

	_mapShown: $.Deferred(),
	mapShown: function(e,match){
		C._mapShown.resolve();
		C._checkGmap();
		if (!M.mapData){
			M.mapData=new MapDataModel();
			V.mapView=new MapView({
				model: M.mapData, el: $("#map"),
				mode: MapView.prototype.ALL
			});
			M.mapData.fetch();
		} else if(M.mapData._fetchFailed){
			M.mapData.fetch();
		}
	},

	mapHidden: function(e,match){
		C._mapShown=null;
		C._mapShown=$.Deferred();
	},

	arrivalsShown: function(e){
		if (!M.departures){
			M.departures=new DeparturesDetailsModel();
			V.departures=new HTMLDetailView({
				el: $("#arrivals .details"), model: M.departures, modelProperty: "departures"
			});
		}
		M.departures.check();
	},

	timetableShown: function(e){
		if (!M.timetable){
			M.timetable=new TimetableTextModel();
			V.timetable=new HTMLDetailView({
				el: $("#timetable .text"), model: M.timetable, modelProperty: "timetableText"
			});
		}
		M.timetable.check();
	},

	pricesShown: function(){
		if (!M.prices){
			M.prices=new PricesModel();
			V.prices=new HTMLDetailView({
				el: $("#ticketprices .details"), model: M.prices, modelProperty: "prices"
			});
		}
		M.prices.check();
	},

	meteoShown: function(){
		if (!M.meteo){
			M.meteo=new MeteoModel();
			V.meteo=new MeteoView({
				el: $("#meteo .details"), model: M.meteo
			});
			M.meteo.fetch();
		} else if (M.meteo._fetchFailed){
			M.meteo.fetch();
		}
	},

	/*applyBgScale: function(e,params){
		var node=params[0];
		var id=node.substr(1);
		if (!M[id]){
			M[id]=true;
			setTimeout(function(){
				$(node).backgroundScale({
					imageSelector: "#imageID"+id,
					centerAlign: false,
					containerPadding: 0
				});
			},200);
		}

	},*/

	ticketPlannerShown: function(e,match,ui){
		if (ui.prevPage && ui.prevPage.hasClass("ui-dialog")){
			return;
		}
		var params;
		if (match[1]) params=C.router.getParams(match[1]);
		if (!params) return;
		if (params.st){
			V.departuresSelect.setValue(params.st);
		}
		if (params.en){
			V.arrivalsSelect.setValue(params.en);
		}
	},

	ticketDetailPage: function(e,match){
		var params, model;
		if (match[1]) params=C.router.getParams(match[1]) || {};

		if (e=="pagehide"){
			if (params.t=="current"){
				console.log("resetting model...");
				M.ticket.clear({silent:true}).set(M.ticket.defaults,{silent:true});
			}
		} else { //pagebeforeshow
			if (params.t=="current"){
				$(".delHistoryTicket").attr("data-params","-1")
					.css("visibility","hidden");
				model=M.ticket;
			} else if (params.id){
				$(".delHistoryTicket").attr("data-params",params.id)
					.css("visibility","visible");
				model=M.ticketCollection.get(params.id);
			}
			if (!V.ticketDetail){
				V.ticketDetail=new TicketDetailView({
					model: model, el: $("#ticketDetail")
				});
			} else {
				V.ticketDetail.setModel(model);
			}
			V.ticketDetail.render();
		}
	},

	ticketConfirmShown: function(){
		if (!M.ticket || M.ticket.validate()) $.mobile.changePage("#index");
		if (!V._countriesSelect){
			V._countriesSelect=true;
			new StandardSelectView({
				model: M.countries, el: $("#ticketConfirm select[name=nazione]"),
				value: "Italy"
			}).render();
			M.countries=null;
		}
	},

	ticketHistoryShown: function(){
		if (!M.ticketCollection){
			M.ticketCollection=new TicketCollectionModel();
			V.ticketCollection=new TicketCollectionView({
				model: M.ticketCollection, el: $("#ticketHistory ul")
			});
			M.ticketCollection.fetch();
		}
	},

	startPayment: function(){
		$.mobile.showPageLoadingMsg();
		M.ticket.fetchOrderId().done(function(){
			var paymentUrl=M.ticket.getPaymentUrl();
			console.log(paymentUrl);
			C._paymentInAppBrowser=window.open(paymentUrl,'_blank','location=yes');
/* debug
setTimeout(function(){
	C.checkPaymentStatus({url: 'http://www.lbalblabalbal.com/uiuiu/uouo/pagine/step_OK.cfm'});
},60000);
*/
			C._paymentInAppBrowser.addEventListener('loadstop',C.checkPaymentStatus);
		}).fail(function(){
			V.dialog.alert(C.getLocalizedString("Errore. Non riesco ad inviare l'ordine. Per favore, controlla la connessione ad internet."));
		}).always(function(){
			$.mobile.hidePageLoadingMsg();
		});
	},

	PAYMENT_OK_URL: "pagine/step_OK.cfm",
	PAYMENT_KO_URL: "pagine/step_KO.cfm",
	checkPaymentStatus: function(e){
		var loc=e.url;
		if (new RegExp(C.PAYMENT_KO_URL, 'i').test(loc)){
			V.dialog.alert(C.getLocalizedString("Pagamento non riuscito"));
			C._paymentInAppBrowser.removeEventListener('loadstop', C.checkPaymentStatus);
			C._paymentInAppBrowser.close();
			C._paymentInAppBrowser = null;
			return;
		}
		if (new RegExp(C.PAYMENT_OK_URL, 'i').test(loc)){
			try {
				C._paymentInAppBrowser.removeEventListener('loadstop', C.checkPaymentStatus);
			}catch(err){}
			C._paymentInAppBrowser.close();
			C._paymentInAppBrowser = null;
			M.ticket.fetch({ // requesting the ticket code
				success: function(){
					$.mobile.changePage("#ticketDetail?t=current");
					M.ticket.save();
				}
			});
			setTimeout(function(){
				V.dialog.alert(C.getLocalizedString("Pagamento completato con successo!"));
			},100);
		}
	} ,

	setupWebDB: function(){
		if (C._websqlOk.state() != 'resolved'){
			persistence.debug=false;
			persistence.store.websql.config(persistence, 'tickets',
				'List of tickets', 2*1024*1024);
			persistence.schemaSync(function(){ C._websqlOk.resolve(); });
		}
	}
};

//$(C).on("languageChanged",C.localize);
C.router=new $.mobile.Router([
	//{ "#index": { events: "i", handler: "initialize" } },
	{ "#ticketPlanner([?].*)?": "ticketPlannerShown" },
	{ "#ticketConfirm": "ticketConfirmShown" },
	{ "#ticketDetail([?].*)?": { handler: "ticketDetailPage", events: "bs,h" } },
	{ "#ticketHistory": "ticketHistoryShown" },
	{ "#map": { handler: "mapHidden", events: "bh" } },
	{ "#map": { handler: "mapShown", events: "s" } },
	{ "#arrivals": "arrivalsShown" },
	{ "#timetable": "timetableShown" },
	{ "#ticketprices": "pricesShown" },
	{ "#meteo": "meteoShown" }
], C);

V.dialog=new DialogView();
M.conf = new ConfigModel();
M.conf.fetch({
	async: false
}).done(function() {
	C._initialized.resolve();
});
$(C.initialize);


document.addEventListener("deviceready", function(e,info){
	deviceReady.resolve();
	/*
	if (device.platform.match(/iPhone|iPad|iOS/i)){
	} else if (device.platform.match(/Android/i)){
		/*document.addEventListener("backbutton", function(e){
			e.preventDefault();
			e.stopPropagation();
			var page=window.location.hash.substring(1);
			if (page.length==0 || page=="index"){
				V.dialog.confirm(getLocalizedString(
					"Do you really want to exit the app?"
				), function(){
					device.exitApp();
				});
			}
			return false;
		},false);
	}
	*/
},false);
